=== Components/FixedImagePyramids/FixedShrinkingPyramid/CMakeLists.txt ===

ADD_ELXCOMPONENT( FixedShrinkingPyramid # Was OFF by default before elastix 5.0.1
 elxFixedShrinkingPyramid.h
 elxFixedShrinkingPyramid.hxx
 elxFixedShrinkingPyramid.cxx)
