=== debian/changelog ===
elastix (5.1.0-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [d71a07b] New upstream version 5.1.0
  * [6fa3afc] Refresh patch doxygen_cleanup.patch
  * [c6562eb] Remove patch no_include_install.patch - build now has configuration for not installing libs.
  * [5700a0d] Tweak configuration and install rules.
  * [1cc1da9] Remove rules pertaining to dox/manual that is no longer part of the sources.
  * [1dee6dc] Add version on itk-dev dependency.
  * [5700a0d] Tweak configuration and install rules.
  * [1cc1da9] Remove rules pertaining to dox/manual that is no longer part of the sources.
  * [1dee6dc] Add version on itk-dev dependency.

 -- Steve M. Robbins <smr@debian.org>  Wed, 21 Jun 2023 22:14:27 -0500
